thx
===

[![Generated by attribution][attribution-badge]][attribution-url]


v0.5.1
------

Bugfix release

- Fix: exit with error code if virtualenvs fail to build (#40)
- Fix: include stderr when python runtimes have unknown version (#39, #64)
- Fix: better virtualenv and binary handling for Windows (#64)
- Docs: updated user guide links and toml section names (#52)

```text
$ git shortlog -s v0.5.0...v0.5.1
    10	Amethyst Reese
     2	John Reese
     1	Tim Hatch
    12	dependabot[bot]
```


v0.5.0
------

Feature release

- `watch_paths` is no longer required for watch mode
- documentation improvements

```text
$ git shortlog -s v0.4.0...v0.5.0
    16	John Reese
     4	dependabot[bot]
```


v0.4.0
------

Feature release

- Feature: new `--watch` flag to trigger jobs on filesystem changes
- Feature: new `Job.show_output` flag
- Feature: config block `[tool.thx.values]`
- Feature: new builtin "list" and "dump-config" commands
- Fix: handle errors when building virtualenvs
- Fix: handle Python versions with local patches (`3.8.6+`)
- Fix: support for Windows cmd prompt

```text
$ git shortlog -s v0.4.0a1...v0.4.0
     9	John Reese
```


v0.4.0a1
--------

Alpha release

- Implemented 'list' and 'dump-config' commands
- Added `--watch` mode
- Added `job.show_output` flag
- Support for Windows cmd.exe

```text
$ git shortlog -s v0.3.0...v0.4.0a1
    25	John Reese
    11	dependabot[bot]
```


v0.3.0
------

Feature release

- Better CLI presentation of jobs and results using Rich (#14)
- New option `--live` to skip version detection (#15)
- Better tracking of runtime versions available (#15)
- Fixed benchmarking on Windows due to lack of time precision

```text
$ git shortlog -s v0.2.0...v0.3.0
     8	John Reese
```


v0.2.0
------

Alpha release

- Essential configuration structure
- Run jobs in separate contexts/virtualenvs in parallel
- Mark jobs as run once, or run all steps in parallel
- See stdout/stderr from failed jobs
- Get overall failure status
- Basic wall clock benchmarking
- Reuse virtualenvs when possible

See `pyproject.toml` for example job specs.

```text
$ git shortlog -s v0.1.0...v0.2.0
    16	John Reese
    10	dependabot[bot]
```


v0.1.0
------

Initial release

* Basic implementation of configuration, contexts, and job running

```text
$ git shortlog -s v0.1.0
    37	John Reese
     2	dependabot[bot]
```

[attribution-badge]:
    https://img.shields.io/badge/generated%20by-attribution-informational
[attribution-url]: https://attribution.omnilib.dev
